program dink_the_head;

uses
 crt,newfrontier,objgfx8,dos;

type DinkObj=object(TScreen8)
             dink:Tgfx8;
             eyes : array[1..19] of word;
             blnk : array[1..8] of word;
             dinkx, dinky : word;
             eyepos : word;
             espeed : word;
             vspeed : word;
             constructor init;
             destructor done; virtual;
             procedure Look_around;
             procedure Head_Up;
             procedure Head_Down;
             procedure Look_Left;
             procedure Look_Right;
             procedure look_center_r;
             procedure look_center_l;
             procedure Blink;
             procedure Run;
     end;
procedure signoff;

begin
  writeln ('Dink! v1.0  a whimsical but complete waste of time');
  writeln;
  writeln ('Dink was designed and coded by Scott Earnest (setech@ix.netcom.com)');
  writeln;
  writeln ('Dink graphics were created with POV-Ray 3.0, with some post-production');
  writeln ('done with DISPLAY and NeoPaint.');
end;

var screen:DinkObj;

constructor DinkObj.init;
var
  f : file;
  p : byte;
  err : integer;
  d : dirstr;
  n : namestr;
  e : extstr;
  s : searchrec;
  size:longint;
  dw,dh:word;
begin
  inherited init;
  screen.setmode(_640x480x8bpp);
  fsplit (paramstr(0),d,n,e);
  findfirst (d+'dink.dat',anyfile,s);
  if doserror<>0 then
    begin
      writeln ('Hey man, DINK.DAT has to be in the same directory as this program to run!');
      writeln;
      signoff;
      halt;
    end;
  assign (f,d+'dink.dat');
  reset (f,1);
  blockread (f,pal,sizeof(pal));
  makepal;
  blockread (f,dw,2);
  blockread (f,dh,2);
  dink.init;
  if not dink.getmem(dw,dh) then halt;
  blockread (f,ptr(dink._data ,0)^,dw*dh);
  for p := 1 to 19 do
    begin
      blockread(f,size,4);
      getmem32(eyes[p],size);
      blockread(f,ptr(eyes[p],0)^,size);
    end;
  for p := 1 to 8 do
    begin
      blockread(f,size,4);
      getmem32(blnk[p],size);
      blockread (f,ptr(blnk[p],0)^,size);
    end;
  close (f);
end;

destructor DinkObj.done;
var i:word;
begin
 inherited done;
 dink.done;
 for i:=1 to 19 do
  freemem32(eyes[i]);
 for i:=1 to 8 do
  freemem32(blnk[i]);
 Signoff;
end;

procedure DinkObj.Run;
begin
  eyepos := 10;
  espeed := 25;
  vspeed := 15;
  repeat
    dinkx := random(getmaxy-90);
    dinky := 20+random(90);
    vspeed := 15+random(35);
    head_up;
    delay (250+random(1500));
    while random(10)<8 do
    begin
     if keypressed then exit;
      look_around;
    end;
    head_down;
    delay (250+random(1500));
  until keypressed;
  while keypressed do readkey;
end;

procedure DinkObj.head_up;

var
  y : word;
  drawn : boolean;

begin
  for y := 0 to dinky do
    begin
     dink.putblit(12,34,ptr48(eyes[eyepos],0));
     copybuf(dinkx,getmaxy-y,dink,0,0,dink.getmaxx,y);
     delay (vspeed);
    end;
end;

procedure DinkObj.head_down;
var
  y : word;
begin
  for y := dinky downto 0 do
    begin
     dink.putblit(12,34,ptr48(eyes[eyepos],0));
     copybuf(dinkx,getmaxy-y,dink,0,0,dink.getmaxx,y);
     line(dinkx,getmaxy-y-1,dinkx+dink.getmaxx,getmaxy-y-1,0);
     delay(vspeed);
    end;
end;

procedure DinkObj.look_left;

var
  p : word;

begin
  if dinky<34 then
    exit;
  for p := 11 to 19 do
    begin
     dink.putblit (12,34,ptr48(eyes[p],0));
     copybuf(dinkx,getmaxy-dinky,dink,0,0,dink.getmaxx,dinky);
     delay(espeed);
    end;
  eyepos := 19;
end;

procedure DinkObj.look_right;

var
  p : word;

begin
  if dinky<34 then
    exit;
  for p := 9 downto 1 do
    begin
     dink.putblit (12,34,ptr48(eyes[p],0));
     copybuf(dinkx,getmaxy-dinky,dink,0,0,dink.getmaxx,dinky);
     delay(espeed);
    end;
  eyepos := 1;
end;

procedure DinkObj.look_center_l;

var
  p : word;

begin
  if dinky<34 then
    exit;
  for p := 18 downto 10 do
    begin
     dink.putblit (12,34,ptr48(eyes[p],0));
     copybuf(dinkx,getmaxy-dinky,dink,0,0,dink.getmaxx,dinky);
     delay(espeed);
    end;
  eyepos := 10;
end;

procedure DinkObj.look_center_r;

var
  p : word;

begin
  if dinky<34 then
    exit;
  for p := 2 to 10 do
    begin
     dink.putblit(12,34,ptr48(eyes[p],0));
     copybuf(dinkx,getmaxy-dinky,dink,0,0,dink.getmaxx,dinky);
     delay(espeed);
    end;
  eyepos := 10;
end;

procedure DinkObj.blink;

var
  b, p : word;

begin
  if dinky<34 then
    exit;
  for b := 1 to random(3)+1 do
    begin
      for p := 1 to 8 do
        begin
          dink.putblit(12,34,ptr48(blnk[p],0));
          copybuf(dinkx,getmaxy-dinky,dink,0,0,dink.getmaxx,dinky);
          delay(15);
        end;
      for p := 7 downto 1 do
        begin
          dink.putblit(12,34,ptr48(blnk[p],0));
          copybuf(dinkx,getmaxy-dinky,dink,0,0,dink.getmaxx,dinky);
          delay(15);
        end;
      dink.putblit(12,34,ptr48(eyes[10],0));
      copybuf(dinkx,getmaxy-dinky,dink,0,0,dink.getmaxx,dinky);
    end;
end;

procedure DinkObj.look_around;

var
  p : word;

begin
  if eyepos=10 then
    if random(5)<3 then
      blink;
  case eyepos of
    1  : look_center_r;
    10 : begin
           case random(2) of
             0 : look_left;
             1 : look_right;
           end;
           espeed := 25+random(50);
         end;
    19 : look_center_l;
  end;
end;

begin
  randomize;
  screen.init;
  screen.run;
  screen.done;
end.